OpenVDB: CacheItem< TreeCacheT, NodeVecT, true > Class Template Reference

OpenVDB 6.1.0

Public Types | Public Member Functions | List of all members
CacheItem< TreeCacheT, NodeVecT, true > Class Template Reference

The tail of a compile-time list of cached node pointers, ordered from LeafNode to RootNode. More...

`#include <ValueAccessor.h>`

## Public Types
using | RootNodeType = typename boost::mpl::front< NodeVecT >::type
using | ValueType = typename RootNodeType::ValueType
using | LeafNodeType = typename RootNodeType::LeafNodeType

## Public Member Functions
| CacheItem (TreeCacheT &parent)
| CacheItem (TreeCacheT &parent, const CacheItem &other)
CacheItem & | copy (TreeCacheT &parent, const CacheItem &other)
bool | isCached (const Coord &xyz) const
void | insert (const Coord &, const RootNodeType *root)
template<typename OtherNodeType >
void | insert (const Coord &, const OtherNodeType *)
void | erase (const RootNodeType *)
void | clear ()
void | getNode (RootNodeType *&node)
void | getNode (const RootNodeType *&node) const
void | addLeaf (LeafNodeType *leaf)
void | addTile (Index level, const Coord &xyz, const ValueType &value, bool state)
LeafNodeType * | touchLeaf (const Coord &xyz)
LeafNodeType * | probeLeaf (const Coord &xyz)
const LeafNodeType * | probeConstLeaf (const Coord &xyz)
template<typename NodeType >
NodeType * | probeNode (const Coord &xyz)
template<typename NodeType >
const NodeType * | probeConstNode (const Coord &xyz)
int | getValueDepth (const Coord &xyz)
bool | isValueOn (const Coord &xyz)
bool | probeValue (const Coord &xyz, ValueType &value)
bool | isVoxel (const Coord &xyz)
const ValueType & | getValue (const Coord &xyz)
void | setValue (const Coord &xyz, const ValueType &value)
void | setValueOnly (const Coord &xyz, const ValueType &value)
void | setValueOn (const Coord &xyz, const ValueType &value)
template<typename ModifyOp >
void | modifyValue (const Coord &xyz, const ModifyOp &op)
template<typename ModifyOp >
void | modifyValueAndActiveState (const Coord &xyz, const ModifyOp &op)
void | setValueOff (const Coord &xyz, const ValueType &value)
void | setActiveState (const Coord &xyz, bool on)

## Detailed Description

### template<typename TreeCacheT, typename NodeVecT>
class openvdb::v6_1::tree::CacheItem< TreeCacheT, NodeVecT, true >

The tail of a compile-time list of cached node pointers, ordered from LeafNode to RootNode.

## Member Typedef Documentation

## ◆ LeafNodeType

using LeafNodeType = typename RootNodeType::LeafNodeType

## ◆ RootNodeType

using RootNodeType = typename boost::mpl::front<NodeVecT>::type

## ◆ ValueType

using ValueType = typename RootNodeType::ValueType

## Constructor & Destructor Documentation

## ◆ CacheItem() [1/2]

CacheItem | ( | TreeCacheT & | parent | ) |
| inline

## ◆ CacheItem() [2/2]

CacheItem | ( | TreeCacheT & | parent,
|  | const CacheItem< TreeCacheT, NodeVecT, true > & | other
| ) |  |
| inline

## Member Function Documentation

## ◆ addLeaf()

void addLeaf | ( | LeafNodeType * | leaf | ) |
| inline

## ◆ addTile()

void addTile | ( | Index | level,
|  | const Coord & | xyz,
|  | const ValueType & | value,
|  | bool | state
| ) |  |
| inline

## ◆ clear()

void clear | ( |  | ) |
| inline

## ◆ copy()

CacheItem& copy | ( | TreeCacheT & | parent,
|  | const CacheItem< TreeCacheT, NodeVecT, true > & | other
| ) |  |
| inline

## ◆ erase()

void erase | ( | const RootNodeType * |  | ) |
| inline

## ◆ getNode() [1/2]

void getNode | ( | RootNodeType *& | node | ) |
| inline

## ◆ getNode() [2/2]

void getNode | ( | const RootNodeType *& | node | ) | const
| inline

## ◆ getValue()

const ValueType& getValue | ( | const Coord & | xyz | ) |
| inline

## ◆ getValueDepth()

int getValueDepth | ( | const Coord & | xyz | ) |
| inline

## ◆ insert() [1/2]

void insert | ( | const Coord & | ,
|  | const RootNodeType * | root
| ) |  |
| inline

## ◆ insert() [2/2]

void insert | ( | const Coord & | ,
|  | const OtherNodeType * |
| ) |  |
| inline

## ◆ isCached()

bool isCached | ( | const Coord & | xyz | ) | const
| inline

## ◆ isValueOn()

bool isValueOn | ( | const Coord & | xyz | ) |
| inline

## ◆ isVoxel()

bool isVoxel | ( | const Coord & | xyz | ) |
| inline

## ◆ modifyValue()

void modifyValue | ( | const Coord & | xyz,
|  | const ModifyOp & | op
| ) |  |
| inline

## ◆ modifyValueAndActiveState()

void modifyValueAndActiveState | ( | const Coord & | xyz,
|  | const ModifyOp & | op
| ) |  |
| inline

## ◆ probeConstLeaf()

const LeafNodeType* probeConstLeaf | ( | const Coord & | xyz | ) |
| inline

## ◆ probeConstNode()

const NodeType* probeConstNode | ( | const Coord & | xyz | ) |
| inline

## ◆ probeLeaf()

LeafNodeType* probeLeaf | ( | const Coord & | xyz | ) |
| inline

## ◆ probeNode()

NodeType* probeNode | ( | const Coord & | xyz | ) |
| inline

## ◆ probeValue()

bool probeValue | ( | const Coord & | xyz,
|  | ValueType & | value
| ) |  |
| inline

## ◆ setActiveState()

void setActiveState | ( | const Coord & | xyz,
|  | bool | on
| ) |  |
| inline

## ◆ setValue()

void setValue | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline

## ◆ setValueOff()

void setValueOff | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline

## ◆ setValueOn()

void setValueOn | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline

## ◆ setValueOnly()

void setValueOnly | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline

## ◆ touchLeaf()

LeafNodeType* touchLeaf | ( | const Coord & | xyz | ) |
| inline

The documentation for this class was generated from the following file:

- ValueAccessor.h